#!/bin/bash

DATE=`date '+%Y-%m-%d %H:%M:%S'`
LOGFILE="/var/log/opmon-probe-conf-change.log"

md5run="/usr/bin/md5sum"

for FILE in /var/cache/merlin/config/*.cfg
do
    MD5FILE="$FILE-MD5SUM"
    if [ -f $MD5FILE ]; then
        oldmd5=`/bin/cat $MD5FILE`
        newmd5=`$md5run $FILE`
        if [ "$oldmd5" == "$newmd5" ]; then
            echo "[$DATE] Same configuration file, no restart needed" >> $LOGFILE
        else
            echo -n "[$DATE] Configuration changed, restarting OpMon..." >> $LOGFILE
	    /usr/local/opmon/bin/opmon-update-precache >> $LOGFILE 2>&1
            /sbin/service opmon restart >> $LOGFILE 2>&1
            echo "done" >> $LOGFILE
            `$md5run $FILE > $MD5FILE`
        fi
    else
        echo "[$DATE] First run, create MD5SUM"
        `$md5run $FILE > $MD5FILE`
    fi
done
